All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2014
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with Git. In case Git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # If '.git-HEAD' is appended to the version, you are seeing an unreleased
20 # version of vcsh; the master branch is supposed to be clean at all times
21 # so you can most likely just use it nonetheless
26 echo "$SELF: fatal: $1" >&2
30 # We need to run getops as soon as possible so we catch -d and other
31 # options that will modify our behaviour.
32 # Commands are handled at the end of this script.
33 while getopts "c:dv" flag; do
34 if [ x"$1" = x'-d' ] || [ x"$1" = x'--debug' ]; then
39 elif [ x"$1" = x'-v' ]; then
41 echo "verbose mode on"
43 elif [ x"$1" = x'-c' ]; then
44 VCSH_OPTION_CONFIG=$OPTARG
50 # Source file even if it's in $PWD and does not have any slashes in it
58 # Read configuration and set defaults if anything's not set
59 [ -n "$VCSH_DEBUG" ] && set -vx
60 : ${XDG_CONFIG_HOME:="$HOME/.config"}
62 # Read configuration files if there are any
63 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
64 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
65 if [ -n "$VCSH_OPTION_CONFIG" ]; then
66 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
67 if [ -r "$VCSH_OPTION_CONFIG" ]; then
68 source_all "$VCSH_OPTION_CONFIG"
70 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
73 [ -n "$VCSH_DEBUG" ] && set -vx
76 : ${VCSH_REPO_D:="$XDG_CONFIG_HOME/vcsh/repo.d"}
77 : ${VCSH_HOOK_D:="$XDG_CONFIG_HOME/vcsh/hooks-enabled"}
78 : ${VCSH_BASE:="$HOME"}
79 : ${VCSH_GITIGNORE:=exact}
80 : ${VCSH_GITATTRIBUTES:=none}
81 : ${VCSH_WORKTREE:=absolute}
83 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
84 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
87 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ] && [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
88 fatal "'\$VCSH_WORKTREE' must equal 'absolute', or 'relative'" 1
93 echo "usage: $SELF <options> <command>
98 -v Enable verbose mode
102 [<repo>] Clone from an existing repository
103 commit Commit in all repositories
104 delete <repo> Delete an existing repository
105 enter <repo> Enter repository; spawn new instance of \$SHELL
106 help Display this help text
107 init <repo> Initialize a new repository
108 list List all repositories
109 list-tracked List all files tracked by vcsh
111 <repo> List files tracked by a repository
112 pull Pull from all vcsh remotes
113 push Push to vcsh remotes
115 <newname> Rename repository
117 <command> Use this repository
118 status [<repo>] Show statuses of all/one vcsh repositories
119 upgrade <repo> Upgrade repository to currently recommended settings
120 version Print version information
121 which <substring> Find substring in name of any tracked file
123 <repo> Write .gitignore.d/<repo> via git ls-files
125 <repo> <git command> Shortcut to run git commands directly
126 <repo> Shortcut to enter repository" >&2
130 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
134 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
138 echo "$SELF: error: $1" >&2
142 echo "$SELF: info: $1"
148 git remote add origin "$GIT_REMOTE"
149 git config branch.master.remote origin
150 git config branch.master.merge refs/heads/master
151 if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
152 info "remote is empty, not merging anything"
157 git ls-tree -r --name-only origin/master | (while read object; do
159 error "'$object' exists." &&
162 [ x"$VCSH_CONFLICT" = x'1' ]) &&
163 fatal "will stop after fetching and not try to merge!
164 Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
165 git merge origin/master
169 hook post-clone-retired
174 for VCSH_REPO_NAME in $(list); do
175 echo "$VCSH_REPO_NAME: "
176 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
178 git commit --untracked-files=no --quiet
179 VCSH_COMMAND_RETURN_CODE=$?
186 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
188 info "This operation WILL DESTROY DATA!"
189 files=$(git ls-files)
190 echo "These files will be deleted:
194 AGAIN, THIS WILL DELETE YOUR DATA!
195 To continue, type 'Yes, do as I say'"
197 [ "x$answer" = 'xYes, do as I say' ] || exit 16
198 for file in $files; do
199 rm -f $file || info "could not delete '$file', continuing with deletion"
201 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
212 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
216 for hook in "$VCSH_HOOK_D/$1"* "$VCSH_HOOK_D/$VCSH_REPO_NAME.$1"*; do
217 [ -x "$hook" ] || continue
218 verbose "executing '$hook'"
225 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
226 mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
227 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
228 git init --shared=0600
234 for repo in "$VCSH_REPO_D"/*.git; do
235 [ -d "$repo" ] && [ -r "$repo" ] && echo "$(basename "$repo" .git)"
240 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
245 for VCSH_REPO_NAME in $(list); do
247 done | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
248 sed 's/[,\&]/\\&/g')," | sort -u
253 git ls-files | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
254 sed 's/[,\&]/\\&/g')," | sort -u
259 for VCSH_REPO_NAME in $(list); do
260 printf '%s: ' "$VCSH_REPO_NAME"
261 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
264 VCSH_COMMAND_RETURN_CODE=$?
272 for VCSH_REPO_NAME in $(list); do
273 printf '%s: ' "$VCSH_REPO_NAME"
274 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
277 VCSH_COMMAND_RETURN_CODE=$?
288 command -v "$1" >/dev/null 2>&1 || fatal "Could not find '$1' command"
294 temp_file_others=$(mktemp) || fatal 'Could not create temp file'
295 temp_file_untracked=$(mktemp) || fatal 'Could not create temp file'
296 temp_file_untracked_copy=$(mktemp) || fatal 'Could not create temp file'
298 # create dummy git repo
299 temp_repo=$(mktemp -d) || fatal 'Could not create temp repo'
301 cd $temp_repo || fatal 'Could not cd into temp repo'
303 mktemp -q -p $(pwd) > /dev/null || fatal 'Could not create dummy file'
305 git commit -q -m "dummy"
308 export GIT_DIR=$temp_repo/.git
309 git ls-files --others --directory | sort -u > $temp_file_untracked
311 for VCSH_REPO_NAME in $(list); do
312 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
313 git ls-files --others --directory | (
316 printf '%s/\n' "$(echo "$line" | cut -d'/' -f1)"
318 ) | sort -u > $temp_file_others
319 cp $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not copy temp file'
320 comm -12 --nocheck-order $temp_file_others $temp_file_untracked_copy > $temp_file_untracked
322 cat $temp_file_untracked
323 rm -f $temp_file_others $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not delete temp files'
324 rm -rf $temp_repo || fatal 'Could not delete temp repo'
329 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
330 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
332 # Now that the repository has been renamed, we need to fix up its configuration
333 # Overwrite old name..
335 VCSH_REPO_NAME=$VCSH_REPO_NAME_NEW
336 # ..and clobber all old configuration
344 VCSH_COMMAND_RETURN_CODE=$?
349 if [ -n "$VCSH_REPO_NAME" ]; then
350 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
352 git status --short --untracked-files='no'
353 VCSH_COMMAND_RETURN_CODE=$?
355 for VCSH_REPO_NAME in $(list); do
356 echo "$VCSH_REPO_NAME:"
357 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
359 git status --short --untracked-files='no'
360 VCSH_COMMAND_RETURN_CODE=$?
368 # fake-bare repositories are not bare, actually. Set this to false
369 # because otherwise Git complains "fatal: core.bare and core.worktree
371 git config core.bare false
372 # core.worktree may be absolute or relative to $GIT_DIR, depending on
374 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
375 git config core.worktree "$(cd "$GIT_DIR" && GIT_WORK_TREE=$VCSH_BASE git rev-parse --show-cdup)"
376 elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
377 git config core.worktree "$VCSH_BASE"
379 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
380 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && git config core.attributesfile ".gitattributes.d/$VCSH_REPO_NAME"
381 git config vcsh.vcsh 'true'
383 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
384 [ -e "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME"
390 VCSH_DIRECTORY=$VCSH_REPO_NAME; export VCSH_DIRECTORY
394 for VCSH_REPO_NAME in $(list); do
395 for VCSH_FILE in $(get_files); do
396 echo "$VCSH_FILE" | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
402 # Don't do anything if the user does not want to write gitignore
403 if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
404 info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
409 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
412 gitignores=$(for file in $(git ls-files); do
414 echo "$file"; new=${file%/*}
415 [ x"$file" = x"$new" ] && break
420 # Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
421 # Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
422 # To make every OS happy, set full path explicitly
423 tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
425 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
426 for gitignore in $gitignores; do
427 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
428 if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
429 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
433 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
434 rm -f "$tempfile" || error "could not delete '$tempfile'"
437 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
438 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
439 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
440 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
442 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
443 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
448 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
449 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
452 VCSH_COMMAND=$1; export VCSH_COMMAND
454 case $VCSH_COMMAND in
455 clon|clo|cl) VCSH_COMMAND=clone;;
456 commi|comm|com|co) VCSH_COMMAND=commit;;
457 delet|dele|del|de) VCSH_COMMAND=delete;;
458 ente|ent|en) VCSH_COMMAND=enter;;
459 hel|he) VCSH_COMMAND=help;;
460 ini|in) VCSH_COMMAND=init;;
461 pul) VCSH_COMMAND=pull;;
462 pus) VCSH_COMMAND=push;;
463 renam|rena|ren|re) VCSH_COMMAND=rename;;
464 ru) VCSH_COMMAND=run;;
465 statu|stat|sta|st) VCSH_COMMAND=status;;
466 upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
467 versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
468 which|whi|wh) VCSH_COMMAND=which;;
469 write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
472 if [ x"$VCSH_COMMAND" = x'clone' ]; then
473 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
475 [ -n "$3" ] && VCSH_REPO_NAME=$3 || VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
476 [ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
477 export VCSH_REPO_NAME
478 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
479 elif [ "$VCSH_COMMAND" = 'version' ]; then
480 echo "$SELF $VERSION"
483 elif [ x"$VCSH_COMMAND" = x'which' ]; then
484 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
485 [ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
486 VCSH_COMMAND_PARAMETER=$2; export VCSH_COMMAND_PARAMETER
487 elif [ x"$VCSH_COMMAND" = x'delete' ] ||
488 [ x"$VCSH_COMMAND" = x'enter' ] ||
489 [ x"$VCSH_COMMAND" = x'init' ] ||
490 [ x"$VCSH_COMMAND" = x'list-tracked-by' ] ||
491 [ x"$VCSH_COMMAND" = x'rename' ] ||
492 [ x"$VCSH_COMMAND" = x'run' ] ||
493 [ x"$VCSH_COMMAND" = x'upgrade' ] ||
494 [ x"$VCSH_COMMAND" = x'write-gitignore' ]; then
495 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify repository to work on" 1
496 [ x"$VCSH_COMMAND" = x'rename' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
497 [ x"$VCSH_COMMAND" = x'run' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
498 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
499 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
500 [ x"$VCSH_COMMAND" = x'rename' ] && { VCSH_REPO_NAME_NEW=$3; export VCSH_REPO_NAME_NEW;
501 GIT_DIR_NEW=$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git; export GIT_DIR_NEW; }
502 [ x"$VCSH_COMMAND" = x'run' ] && shift 2
503 elif [ x"$VCSH_COMMAND" = x'commit' ] ||
504 [ x"$VCSH_COMMAND" = x'list' ] ||
505 [ x"$VCSH_COMMAND" = x'list-tracked' ] ||
506 [ x"$VCSH_COMMAND" = x'list-untracked' ] ||
507 [ x"$VCSH_COMMAND" = x'pull' ] ||
508 [ x"$VCSH_COMMAND" = x'push' ]; then
510 elif [ x"$VCSH_COMMAND" = x'status' ]; then
511 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
512 elif [ -n "$2" ]; then
513 VCSH_COMMAND='run'; export VCSH_COMMAND
514 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
515 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
516 [ -d "$GIT_DIR" ] || { help; exit 1; }
519 elif [ -n "$VCSH_COMMAND" ]; then
520 VCSH_COMMAND='enter'; export VCSH_COMMAND
521 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
522 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
523 [ -d "$GIT_DIR" ] || { help; exit 1; }
525 # $1 is empty, or 'help'
529 # Did we receive a directory instead of a name?
530 # Mangle the input to fit normal operation.
531 if echo "$VCSH_REPO_NAME" | grep -q '/'; then
532 GIT_DIR=$VCSH_REPO_NAME; export GIT_DIR
533 VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git); export VCSH_REPO_NAME
538 if [ ! -d "$check_directory" ]; then
539 if [ -e "$check_directory" ]; then
540 fatal "'$check_directory' exists but is not a directory" 13
542 verbose "attempting to create '$check_directory'"
543 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
548 check_dir "$VCSH_REPO_D"
549 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
550 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && check_dir "$VCSH_BASE/.gitattributes.d"
552 verbose "$VCSH_COMMAND begin"
553 VCSH_COMMAND=$(echo "$VCSH_COMMAND" | sed 's/-/_/g'); export VCSH_COMMAND
557 verbose "$VCSH_COMMAND end, exiting"
558 exit $VCSH_COMMAND_RETURN_CODE